最近写了一个接口程序,主程序在调用接口程序的时候,程序出错抛出异常,同时返回NULL值,经过分析代码,感觉既然抛出异常了,就不应该再有后面程序的返回值的程序的继续执行了。后来经过测试验证,并从网上寻找答案,对抛出异常,后续程序是否继续执行有了新的理解。

由于网上有一篇文章写的确实比较细致,这里就直接照搬过来以备记录了。

引用文章地址:https://www.cnblogs.com/wangyingli/p/5912269.html

//代码1 
public static void test() throws Exception  { 
 
    throw new Exception("参数越界");  
    System.out.println("异常后"); //编译错误,「无法访问的语句」 
}
//代码2 
try{ 
    throw new Exception("参数越界");  
}catch(Exception e) { 
    e.printStackTrace(); 
} 
System.out.println("异常后");//可以执行
//代码3 
if(true) { 
    throw new Exception("参数越界");  
} 
System.out.println("异常后"); //抛出异常,不会执行

总结:

  1. 若一段代码前有异常抛出,并且这个异常没有被捕获,这段代码将产生编译时错误「无法访问的语句」。如代码1
  2. 若一段代码前有异常抛出,并且这个异常被try...catch所捕获,若此时catch语句中没有抛出新的异常,则这段代码能够被执行,否则,同第1条。如代码2
  3. 若在一个条件语句中抛出异常,则程序能被编译,但后面的语句不会被执行。如代码3

另外总结一下运行时异常与非运行时异常的区别:

  • 运行时异常是RuntimeException类及其子类的异常,是非受检异常,如NullPointerException、IndexOutOfBoundsException等。由于这类异常要么是系统异常,无法处理,如网络问题;
    要么是程序逻辑错误,如空指针异常;JVM必须停止运行以改正这种错误,所以运行时异常可以不进行处理(捕获或向上抛出,当然也可以处理),而由JVM自行处理。Java Runtime会自动catch到程序throw的RuntimeException,然后停止线程,打印异常。

  • 非运行时异常是RuntimeException以外的异常,类型上都属于Exception类及其子类,是受检异常。非运行时异常必须进行处理(捕获或向上抛出),如果不处理,程序将出现编译错误。一般情况下,API中写了throws的Exception都不是RuntimeException。

常见运行时异常:

常见非运行时异常:


发布评论
IT序号网

微信公众号号:IT虾米 (左侧二维码扫一扫)欢迎添加!

Servlet简介与Servlet和HttpServlet运行的流程知识解答
你是第一个吃螃蟹的人
发表评论

◎欢迎参与讨论,请在这里发表您的看法、交流您的观点。